unit Tic_Tac_Toe_A_pas;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Sprite_Blu: TShape;
    Sprite_Verde: TShape;
    Sprite_Rosso: TShape;


    procedure FormCreate(Sender: TObject);
    procedure Sprite_BluMouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure Sprite_BluMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure Sprite_BluMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Sprite_RossoMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Sprite_RossoMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer );
    procedure Sprite_RossoMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Sprite_VerdeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Sprite_VerdeMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Sprite_VerdeMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

  private

  public

  end;

var
  Form1: TForm1;
  Posizione_X_Rosso, Posizione_Y_Rosso,Posizione_X_Blu, Posizione_Y_blu, Posizione_X_Verde, Posizione_Y_Verde  : Integer;
  Var Premuto_Rosso, Premuto_Blu, Premuto_Verde: Boolean;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Sprite_RossoMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
Var Differenza_X, Differenza_Y: Integer;
begin
  If Premuto_Rosso = false Then Exit;
  // Calcola la diferenza tra la posizione precedente e quella attuale
Differenza_X:= X - Posizione_X_Rosso;
Differenza_Y:= Y - Posizione_Y_Rosso;
  Sprite_Rosso.Left:= Sprite_Rosso.Left + Differenza_X;
  Sprite_Rosso.Top:= Sprite_Rosso.Top + Differenza_Y;
end;

procedure TForm1.Sprite_RossoMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Premuto_Rosso:= False;
end;

procedure TForm1.Sprite_VerdeMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  // Memorizza la posizione X Y del mouse quando si preme il pulsante
  Premuto_Verde:=True;
  Posizione_X_Verde:= X;
  Posizione_Y_Verde:= Y;
end;

procedure TForm1.Sprite_VerdeMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
Var Differenza_X, Differenza_Y: Integer;
begin
  If Premuto_Verde = false Then Exit;
  // Calcola la diferenza tra la posizione precedente e quella attuale
Differenza_X:= X - Posizione_X_Verde;
Differenza_Y:= Y - Posizione_Y_Verde;
  Sprite_Verde.Left:= Sprite_Verde.Left + Differenza_X;
  Sprite_Verde.Top:= Sprite_Verde.Top + Differenza_Y;
end;

procedure TForm1.Sprite_VerdeMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Premuto_Verde:= False;
end;

procedure TForm1.Sprite_RossoMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  // Memorizza la posizione X Y del mouse quando si preme il pulsante
  Premuto_Rosso:=True;
  Posizione_X_Rosso:= X;
  Posizione_Y_Rosso:= Y;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // Istruzioni non necessarie: all'inizio le variabili Boolean sono tutte False
  // Premuto_Rosso:=False;
  // Premuto_Verde:=False;
  // Premuto_Blu:=False;
end;

procedure TForm1.Sprite_BluMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  // Memorizza la posizione X Y del mouse quando si preme il pulsante
  Premuto_Blu:=True;
  Posizione_X_Blu:= X;
  Posizione_Y_Blu:= Y;
end;

procedure TForm1.Sprite_BluMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
Var Differenza_X_Blu, Differenza_Y_Blu: Integer;
begin
  If Premuto_Blu = false Then Exit;
  // Calcola la diferenza tra la posizione precedente e quella attuale
Differenza_X_Blu:= X - Posizione_X_Blu;
Differenza_Y_Blu:= Y - Posizione_Y_Blu;
  Sprite_Blu.Left:= Sprite_Blu.Left + Differenza_X_Blu;
  Sprite_Blu.Top:= Sprite_Blu.Top + Differenza_Y_Blu;
 End;

procedure TForm1.Sprite_BluMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Premuto_Blu:= False;
end;

end.

